com.google.cloud.dataflow.sdk.io

## Class Read.Unbounded<T>

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.PTransform<PInput,PCollection<T>>
  - - com.google.cloud.dataflow.sdk.io.Read.Unbounded<T>

All Implemented Interfaces:
  HasDisplayData, Serializable

Enclosing class:
  Read

    public static class Read.Unbounded<T>
    extends PTransform<PInput,PCollection<T>>

`PTransform` that reads from a `UnboundedSource`.

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`name`

### Method Summary

All Methods Instance Methods Concrete Methods
`PCollection<T>` `apply(PInput input)` Applies this `PTransform` on the given `InputT`, and returns its `Output`.
`protected Coder<T>` `getDefaultOutputCoder()` Returns the default `Coder` to use for the output of this single-output `PTransform`.
`String` `getKindString()` Returns the name to use by default for this `PTransform` (not including the names of any enclosing `PTransform`s).
`UnboundedSource<T,?>` `getSource()` Returns the `UnboundedSource` used to create this `Read` `PTransform`.
`Read.Unbounded<T>` `named(String name)` Returns a new `Unbounded` `PTransform` that's like this one but has the given name.
`void` `populateDisplayData(DisplayData.Builder builder)` Register display data for the given transform or component.
`com.google.cloud.dataflow.sdk.io.BoundedReadFromUnboundedSource<T>` `withMaxNumRecords(long maxNumRecords)` Returns a new `BoundedReadFromUnboundedSource` that reads a bounded amount of data from the given `UnboundedSource`.
`com.google.cloud.dataflow.sdk.io.BoundedReadFromUnboundedSource<T>` `withMaxReadTime(Duration maxReadTime)` Returns a new `BoundedReadFromUnboundedSource` that reads a bounded amount of data from the given `UnboundedSource`.

### Methods inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`getDefaultOutputCoder, getDefaultOutputCoder, getName, toString, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### named

    public Read.Unbounded<T> named(String name)

Returns a new `Unbounded` `PTransform` that's like this one but has the given name.

Does not modify this object.

#### withMaxNumRecords

    public com.google.cloud.dataflow.sdk.io.BoundedReadFromUnboundedSource<T> withMaxNumRecords(long maxNumRecords)

Returns a new `BoundedReadFromUnboundedSource` that reads a bounded amount of data from the given `UnboundedSource`. The bound is specified as a number of records to read.

This may take a long time to execute if the splits of this source are slow to read records.

#### withMaxReadTime

    public com.google.cloud.dataflow.sdk.io.BoundedReadFromUnboundedSource<T> withMaxReadTime(Duration maxReadTime)

Returns a new `BoundedReadFromUnboundedSource` that reads a bounded amount of data from the given `UnboundedSource`. The bound is specified as an amount of time to read for. Each split of the source will read for this much time.

#### getDefaultOutputCoder

    protected Coder<T> getDefaultOutputCoder()

Description copied from class: `PTransform`
Returns the default `Coder` to use for the output of this single-output `PTransform`.

By default, always throws

Overrides:
  `getDefaultOutputCoder` in class `PTransform<PInput,PCollection<T>>`

#### apply

    public final PCollection<T> apply(PInput input)

Description copied from class: `PTransform`
Applies this `PTransform` on the given `InputT`, and returns its `Output`.

Composite transforms, which are defined in terms of other transforms, should return the output of one of the composed transforms. Non-composite transforms, which do not apply any transforms internally, should return a new unbound output and register evaluators (via backend-specific registration methods).

The default implementation throws an exception. A derived class must either implement apply, or else each runner must supply a custom implementation via `PipelineRunner.apply(com.google.cloud.dataflow.sdk.transforms.PTransform<InputT, OutputT>, InputT)`.

Overrides:
  `apply` in class `PTransform<PInput,PCollection<T>>`

#### getSource

    public UnboundedSource<T,?> getSource()

Returns the `UnboundedSource` used to create this `Read` `PTransform`.

#### getKindString

    public String getKindString()

Description copied from class: `PTransform`
Returns the name to use by default for this `PTransform` (not including the names of any enclosing `PTransform`s).

By default, returns the base name of this `PTransform`'s class.

The caller is responsible for ensuring that names of applied `PTransform`s are unique, e.g., by adding a uniquifying suffix when needed.

Overrides:
  `getKindString` in class `PTransform<PInput,PCollection<T>>`

#### populateDisplayData

    public void populateDisplayData(DisplayData.Builder builder)

Description copied from class: `PTransform`
Register display data for the given transform or component.

`populateDisplayData(DisplayData.Builder)` is invoked by Pipeline runners to collect display data via `DisplayData.from(HasDisplayData)`. Implementations may call `super.populateDisplayData(builder)` in order to register display data in the current namespace, but should otherwise use `subcomponent.populateDisplayData(builder)` to use the namespace of the subcomponent.

By default, does not register any display data. Implementors may override this method to provide their own display data.

Specified by:
  `populateDisplayData` in interface `HasDisplayData`
Overrides:
  `populateDisplayData` in class `PTransform<PInput,PCollection<T>>`
Parameters:
  `builder` - The builder to populate with display data.
See Also:
  `HasDisplayData`